title: CodeForces 786A Berzerk

data: 2018-3-3 10:29:40

tags:

  • 博弈论
  • bfs
  • 无限
  • with draw

    copyright: true

    categories:
  • 信息学竞赛
  • 题目

    description: 有一个环, 1的位置是黑洞, 有一个怪物在任意位置上, 两个人依次行动, 可以将怪物移动自己决策集合中的任意步, 谁先把它送进黑洞谁就赢, 请输出当怪物在任意位置和谁先手的各自的胜负情况, 有平局.

A. Berzerk

description

  Rick and Morty are playing their own version of Berzerk (which has nothing in common with the famous Berzerk game). This game needs a huge space, so they play it with a computer.

  In this game there are n objects numbered from 1 to n arranged in a circle (in clockwise order). Object number 1 is a black hole and the others are planets. There's a monster in one of the planet. Rick and Morty don't know on which one yet, only that he's not initially in the black hole, but Unity will inform them before the game starts. But for now, they want to be prepared for every possible scenario.

  Each one of them has a set of numbers between 1 and n - 1 (inclusive). Rick's set is s1 with k1 elements and Morty's is s2 with k2 elements. One of them goes first and the player changes alternatively. In each player's turn, he should choose an arbitrary number like x from his set and the monster will move to his x-th next object from its current position (clockwise). If after his move the monster gets to the black hole he wins.

  Your task is that for each of monster's initial positions and who plays first determine if the starter wins, loses, or the game will stuck in an infinite loop. In case when player can lose or make game infinity, it more profitable to choose infinity game.

Input

  The first line of input contains a single integer n (\(2 ≤ n ≤ 7000\)) — number of objects in game.

  The second line contains integer k1 followed by k1 distinct integers s1, 1, s1, 2, ..., s1, k1 — Rick's set.

  The third line contains integer k2 followed by k2 distinct integers s2, 1, s2, 2, ..., s2, k2 — Morty's set

\(1 ≤ ki ≤ n - 1\ and\ 1 ≤ si, 1, si, 2, ..., si, ki ≤ n - 1\ for\ 1 ≤ i ≤ 2.\)

Output

  In the first line print n - 1 words separated by spaces where i-th word is "Win" (without quotations) if in the scenario that Rick plays first and monster is initially in object number i + 1 he wins, "Lose" if he loses and "Loop" if the game will never end.

  Similarly, in the second line print n - 1 words separated by spaces where i-th word is "Win" (without quotations) if in the scenario that Morty plays first and monster is initially in object number i + 1 he wins, "Lose" if he loses and "Loop" if the game will never end.

Examples

input #1

5

2 3 2

3 1 2 3

output #1

Lose Win Win Loop

Loop Win Win Win

input #2

8

4 6 2 3 4

2 3 6

output #2

Win Win Win Win Win Win Win

Lose Win Lose Lose Win Lose Lose

Way:

  这显然是一个无限博弈问题, 因为两人都选择最佳策略, 所以两个人有可能一直僵持下去谁也奈何不了谁, 这显然就是平局.

  显然可以用搜索搜出每个状态的所有后继状态, 根据必败态和必胜态的定义.

  • 终止状态是必败态.
  • 有一个后继状态是必败态的状态是必胜态.
  • 所以后继状态都是必胜态的状态是必败态.

  通过这样可以推出所有的必胜态和必败态.可是平局如何定义呢?后继状态有不确定状态的状态是不确定状态, 可以发现它构成了一个环.

Code

#include<algorithm>
#include<iostream>
#include<cstdlib>
#include<cstdio>
#include<queue>
#define N 7005
using namespace std; namespace Input{
inline int read(){
char ch=getchar();int s=0;
for(;!isdigit(ch);ch=getchar());
for(;isdigit(ch);s=s*10+ch-'0',ch=getchar());
return s;
}
inline void read(int &s){
char ch=getchar();
for(;!isdigit(ch);ch=getchar());
for(s=0;isdigit(ch);s=s*10+ch-'0',ch=getchar());
}
};using namespace Input;
struct Move{
int pos;
bool now;
Move(int _pos=0,bool _now=1){pos=_pos;now=_now;}
}; int mark[N][2],alt[N][2];
int vis[N][2],du[N][2];
int f[N][2],s[2],n; int mov(int pos,int step){
return (pos-step+n)%n;
}
void bfs(){
queue<Move>que;
f[0][1]=f[0][0]=2;
que.push((Move){0,0});
que.push((Move){0,1});
vis[0][1]=true;
vis[0][0]=true;
while(!que.empty()){
Move top=que.front();que.pop();
bool opt=top.now^1;
for(int i=0;i<s[opt];++i){
int to=mov(top.pos,alt[i][opt]);
if(f[top.pos][top.now]==1){
mark[to][opt]++;
if(!vis[to][opt]&&mark[to][opt]==s[opt]){
f[to][opt]=2;
vis[to][opt]=true;
que.push((Move){to,opt});
}
}
else if(!vis[to][opt]){
f[to][opt]=1;
vis[to][opt]=true;
que.push((Move){to,opt});
}
}
}
} int main(){
read(n);
read(s[0]);
for(int i=0;i<s[0];++i)read(alt[i][0]);
read(s[1]);
for(int i=0;i<s[1];++i)read(alt[i][1]);
bfs();int ans;
for(int i=1;i<n;++i){
ans=f[i][0];
printf(ans?ans==1?"Win":"Lose":"Loop");
putchar(' ');
}
putchar('\n');
for(int i=1;i<n;++i){
ans=f[i][1];
printf(ans?ans==1?"Win":"Lose":"Loop");
putchar(' ');
}
system("pause");
return 0;
}

cf786a的更多相关文章

  1. CF786A - Berzerk

    /* CF786A - Berzerk http://codeforces.com/contest/786/problem/A 博弈论 直接搜出NP状态图.记得要记忆化剪枝. * */ #includ ...

随机推荐

  1. POJ2749:Building roads——题解

    http://poj.org/problem?id=2749 (这个约翰的奶牛真多事…………………………) i表示u与s1连,i+n表示u与s2连. 老规矩,u到v表示取u必须取v. 那么对于互相打架 ...

  2. BZOJ1061:[NOI2008]志愿者招募——题解

    https://www.lydsy.com/JudgeOnline/problem.php?id=1061 https://www.luogu.org/problemnew/show/P3980 申奥 ...

  3. 斜率优化第一题! HDU3507 | 单调队列优化DP

    放一手原题 题解: 第一次写(抄)斜率优化,心里还是有点小激动的.讲一下怎么实现的! 首先我们可以考虑一个朴素的dp:DP[i]表示前i个数字的最少花费,显然我们有一个转移方程 DP[i]=min{D ...

  4. 数组分组chunk的一种写法

    lodash的_.chunk函数可以将数组按照数量分成若干组, 例如: const data = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]; const groupByN ...

  5. ACE自适配通信环境简介

    转载于:http://www.cnblogs.com/TianFang/archive/2006/12/03/580795.html ACE自适配通信环境 (Adaptive Communicatio ...

  6. Qt ------ 内存回收机制、new对象的回收

    写在前面的总结: 建议:对于不能指定父对象的对象(对象通过moveToThread()移入其他线程.没有继承QObject的类产生的对象),在其他线程通过deleteLater()内存回收,其他通过指 ...

  7. zigbee ------ JN5169低功耗设置

    低功耗睡眠设置Power Manager (PWRM) PWRM_vInit() 如果进入睡眠模式,设置芯片进入何种睡眠模式 PWRM_eScheduleActivity()设置进入睡眠多长时间(时钟 ...

  8. Java设计模式の装饰者模式

    目录 一.问题引入 二.设计原则 三.用装饰者模式解决问题 四.装饰者模式的特点 五.装饰者模式的定义 六.装饰者模式的实现 七.java.io包内的装饰者模式 一.问题引入 咖啡店的类设计: 一个饮 ...

  9. Hibernate入门(3)- 持久对象的生命周期介绍

    在hibernate中对象有三种状态:瞬时态(Transient). 持久态(Persistent).脱管态或游离态(Detached).处于持久态的对象也称为PO(Persistence Objec ...

  10. iOS 隐藏导航栏下的黑线

    一.找到导航栏下的黑线 // 寻找导航栏下的黑线 - (UIImageView *)findHairlineImageViewUnder:(UIView *)view { if ([view isKi ...